/* SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause) */

/* THIS FILE IS AUTOGENERATED! */
#ifndef __TRACE_PRINTK_SKEL_H__
#define __TRACE_PRINTK_SKEL_H__

#include <stdlib.h>
#include <bpf/libbpf.h>

struct trace_printk {
	struct bpf_object_skeleton *skeleton;
	struct bpf_object *obj;
	struct {
		struct bpf_map *rodata;
		struct bpf_map *bss;
	} maps;
	struct {
		struct bpf_program *sys_enter;
	} progs;
	struct {
		struct bpf_link *sys_enter;
	} links;
	struct trace_printk__bss {
		int trace_printk_ret;
		int trace_printk_ran;
	} *bss;
	struct trace_printk__rodata {
		char sys_enter_fmt[20];
	} *rodata;
};

static void
trace_printk__destroy(struct trace_printk *obj)
{
	if (!obj)
		return;
	if (obj->skeleton)
		bpf_object__destroy_skeleton(obj->skeleton);
	free(obj);
}

static inline int
trace_printk__create_skeleton(struct trace_printk *obj);

static inline struct trace_printk *
trace_printk__open_opts(const struct bpf_object_open_opts *opts)
{
	struct trace_printk *obj;

	obj = (struct trace_printk *)calloc(1, sizeof(*obj));
	if (!obj)
		return NULL;
	if (trace_printk__create_skeleton(obj))
		goto err;
	if (bpf_object__open_skeleton(obj->skeleton, opts))
		goto err;

	return obj;
err:
	trace_printk__destroy(obj);
	return NULL;
}

static inline struct trace_printk *
trace_printk__open(void)
{
	return trace_printk__open_opts(NULL);
}

static inline int
trace_printk__load(struct trace_printk *obj)
{
	return bpf_object__load_skeleton(obj->skeleton);
}

static inline struct trace_printk *
trace_printk__open_and_load(void)
{
	struct trace_printk *obj;

	obj = trace_printk__open();
	if (!obj)
		return NULL;
	if (trace_printk__load(obj)) {
		trace_printk__destroy(obj);
		return NULL;
	}
	return obj;
}

static inline int
trace_printk__attach(struct trace_printk *obj)
{
	return bpf_object__attach_skeleton(obj->skeleton);
}

static inline void
trace_printk__detach(struct trace_printk *obj)
{
	return bpf_object__detach_skeleton(obj->skeleton);
}

static inline int
trace_printk__create_skeleton(struct trace_printk *obj)
{
	struct bpf_object_skeleton *s;

	s = (struct bpf_object_skeleton *)calloc(1, sizeof(*s));
	if (!s)
		return -1;
	obj->skeleton = s;

	s->sz = sizeof(*s);
	s->name = "trace_printk";
	s->obj = &obj->obj;

	/* maps */
	s->map_cnt = 2;
	s->map_skel_sz = sizeof(*s->maps);
	s->maps = (struct bpf_map_skeleton *)calloc(s->map_cnt, s->map_skel_sz);
	if (!s->maps)
		goto err;

	s->maps[0].name = "trace_pr.rodata";
	s->maps[0].map = &obj->maps.rodata;
	s->maps[0].mmaped = (void **)&obj->rodata;

	s->maps[1].name = "trace_pr.bss";
	s->maps[1].map = &obj->maps.bss;
	s->maps[1].mmaped = (void **)&obj->bss;

	/* programs */
	s->prog_cnt = 1;
	s->prog_skel_sz = sizeof(*s->progs);
	s->progs = (struct bpf_prog_skeleton *)calloc(s->prog_cnt, s->prog_skel_sz);
	if (!s->progs)
		goto err;

	s->progs[0].name = "sys_enter";
	s->progs[0].prog = &obj->progs.sys_enter;
	s->progs[0].link = &obj->links.sys_enter;

	s->data_sz = 2120;
	s->data = (void *)"\
\x7f\x45\x4c\x46\x02\x01\x01\0\0\0\0\0\0\0\0\0\x01\0\xf7\0\x01\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\xc8\x05\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\0\0\x40\0\x0a\0\
\x01\0\0\x2e\x73\x74\x72\x74\x61\x62\0\x2e\x73\x79\x6d\x74\x61\x62\0\x74\x70\
\x2f\x72\x61\x77\x5f\x73\x79\x73\x63\x61\x6c\x6c\x73\x2f\x73\x79\x73\x5f\x65\
\x6e\x74\x65\x72\0\x6c\x69\x63\x65\x6e\x73\x65\0\x2e\x62\x73\x73\0\x2e\x72\x6f\
\x64\x61\x74\x61\0\x74\x72\x61\x63\x65\x5f\x70\x72\x69\x6e\x74\x6b\x2e\x63\0\
\x73\x79\x73\x5f\x65\x6e\x74\x65\x72\x2e\x66\x6d\x74\0\x73\x79\x73\x5f\x65\x6e\
\x74\x65\x72\0\x74\x72\x61\x63\x65\x5f\x70\x72\x69\x6e\x74\x6b\x5f\x72\x61\x6e\
\0\x74\x72\x61\x63\x65\x5f\x70\x72\x69\x6e\x74\x6b\x5f\x72\x65\x74\0\x5f\x6c\
\x69\x63\x65\x6e\x73\x65\0\x2e\x72\x65\x6c\x74\x70\x2f\x72\x61\x77\x5f\x73\x79\
\x73\x63\x61\x6c\x6c\x73\x2f\x73\x79\x73\x5f\x65\x6e\x74\x65\x72\0\x2e\x42\x54\
\x46\0\x2e\x42\x54\x46\x2e\x65\x78\x74\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\x40\0\0\0\x04\0\xf1\xff\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x03\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x4f\0\0\0\x01\0\x06\0\0\0\0\0\0\0\
\0\0\x14\0\0\0\0\0\0\0\0\0\0\0\x03\0\x06\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x5d\
\0\0\0\x12\0\x03\0\0\0\0\0\0\0\0\0\x70\0\0\0\0\0\0\0\x67\0\0\0\x11\0\x05\0\x04\
\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\x78\0\0\0\x11\0\x05\0\0\0\0\0\0\0\0\0\x04\0\0\
\0\0\0\0\0\x89\0\0\0\x11\0\x04\0\0\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\x18\x01\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\x61\x13\0\0\0\0\0\0\x04\x03\0\0\x01\0\0\0\x63\x31\0\0\
\0\0\0\0\x18\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xb4\x02\0\0\x14\0\0\0\x85\0\0\0\
\x06\0\0\0\x18\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x63\x01\0\0\0\0\0\0\xb4\0\0\0\0\
\0\0\0\x95\0\0\0\0\0\0\0\x47\x50\x4c\0\x74\x65\x73\x74\x69\x6e\x67\x2c\x74\x65\
\x73\x74\x69\x6e\x67\x20\x25\x64\x0a\0\0\0\0\0\0\0\0\0\x01\0\0\0\x06\0\0\0\x28\
\0\0\0\0\0\0\0\x01\0\0\0\x04\0\0\0\x48\0\0\0\0\0\0\0\x01\0\0\0\x07\0\0\0\x9f\
\xeb\x01\0\x18\0\0\0\0\0\0\0\x2c\x01\0\0\x2c\x01\0\0\x6e\x01\0\0\0\0\0\0\0\0\0\
\x02\0\0\0\0\0\0\0\0\x01\0\0\x0d\x03\0\0\0\x01\0\0\0\x01\0\0\0\x05\0\0\0\0\0\0\
\x01\x04\0\0\0\x20\0\0\x01\x09\0\0\0\x01\0\0\x0c\x02\0\0\0\x13\0\0\0\0\0\0\x01\
\x01\0\0\0\x08\0\0\x01\0\0\0\0\0\0\0\x03\0\0\0\0\x05\0\0\0\x07\0\0\0\x04\0\0\0\
\x18\0\0\0\0\0\0\x01\x04\0\0\0\x20\0\0\0\x2c\0\0\0\0\0\0\x0e\x06\0\0\0\x01\0\0\
\0\x35\0\0\0\0\0\0\x0e\x03\0\0\0\x01\0\0\0\x46\0\0\0\0\0\0\x0e\x03\0\0\0\x01\0\
\0\0\0\0\0\0\0\0\0\x0a\x05\0\0\0\0\0\0\0\0\0\0\x03\0\0\0\0\x0b\0\0\0\x07\0\0\0\
\x14\0\0\0\x57\0\0\0\0\0\0\x0e\x0c\0\0\0\0\0\0\0\x3f\x01\0\0\x01\0\0\x0f\x04\0\
\0\0\x08\0\0\0\0\0\0\0\x04\0\0\0\x47\x01\0\0\x02\0\0\x0f\x08\0\0\0\x09\0\0\0\0\
\0\0\0\x04\0\0\0\x0a\0\0\0\x04\0\0\0\x04\0\0\0\x4c\x01\0\0\x01\0\0\x0f\x14\0\0\
\0\x0d\0\0\0\0\0\0\0\x14\0\0\0\0\x63\x74\x78\0\x69\x6e\x74\0\x73\x79\x73\x5f\
\x65\x6e\x74\x65\x72\0\x63\x68\x61\x72\0\x5f\x5f\x41\x52\x52\x41\x59\x5f\x53\
\x49\x5a\x45\x5f\x54\x59\x50\x45\x5f\x5f\0\x5f\x6c\x69\x63\x65\x6e\x73\x65\0\
\x74\x72\x61\x63\x65\x5f\x70\x72\x69\x6e\x74\x6b\x5f\x72\x65\x74\0\x74\x72\x61\
\x63\x65\x5f\x70\x72\x69\x6e\x74\x6b\x5f\x72\x61\x6e\0\x73\x79\x73\x5f\x65\x6e\
\x74\x65\x72\x2e\x66\x6d\x74\0\x2f\x62\x75\x69\x6c\x64\x64\x69\x72\x2f\x62\x75\
\x69\x6c\x64\x2f\x42\x55\x49\x4c\x44\x2f\x6b\x65\x72\x6e\x65\x6c\x2d\x34\x2e\
\x31\x38\x2e\x30\x2d\x33\x35\x38\x2e\x65\x6c\x38\x2f\x6c\x69\x6e\x75\x78\x2d\
\x34\x2e\x31\x38\x2e\x30\x2d\x33\x35\x38\x2e\x65\x6c\x38\x2e\x70\x70\x63\x36\
\x34\x6c\x65\x2f\x74\x6f\x6f\x6c\x73\x2f\x74\x65\x73\x74\x69\x6e\x67\x2f\x73\
\x65\x6c\x66\x74\x65\x73\x74\x73\x2f\x62\x70\x66\x2f\x70\x72\x6f\x67\x73\x2f\
\x74\x72\x61\x63\x65\x5f\x70\x72\x69\x6e\x74\x6b\x2e\x63\0\x09\x09\x09\x09\x09\
\x20\x20\x20\x20\x2b\x2b\x74\x72\x61\x63\x65\x5f\x70\x72\x69\x6e\x74\x6b\x5f\
\x72\x61\x6e\x29\x3b\0\x09\x74\x72\x61\x63\x65\x5f\x70\x72\x69\x6e\x74\x6b\x5f\
\x72\x65\x74\x20\x3d\x20\x62\x70\x66\x5f\x74\x72\x61\x63\x65\x5f\x70\x72\x69\
\x6e\x74\x6b\x28\x66\x6d\x74\x2c\x20\x73\x69\x7a\x65\x6f\x66\x28\x66\x6d\x74\
\x29\x2c\0\x09\x72\x65\x74\x75\x72\x6e\x20\x30\x3b\0\x6c\x69\x63\x65\x6e\x73\
\x65\0\x2e\x62\x73\x73\0\x2e\x72\x6f\x64\x61\x74\x61\0\x74\x70\x2f\x72\x61\x77\
\x5f\x73\x79\x73\x63\x61\x6c\x6c\x73\x2f\x73\x79\x73\x5f\x65\x6e\x74\x65\x72\0\
\0\0\0\0\0\0\x9f\xeb\x01\0\x20\0\0\0\0\0\0\0\x14\0\0\0\x14\0\0\0\x4c\0\0\0\x60\
\0\0\0\0\0\0\0\x08\0\0\0\x54\x01\0\0\x01\0\0\0\0\0\0\0\x04\0\0\0\x10\0\0\0\x54\
\x01\0\0\x04\0\0\0\0\0\0\0\x65\0\0\0\xdf\0\0\0\x0a\x4c\0\0\x28\0\0\0\x65\0\0\0\
\xfd\0\0\0\x15\x48\0\0\x48\0\0\0\x65\0\0\0\xfd\0\0\0\x13\x48\0\0\x60\0\0\0\x65\
\0\0\0\x34\x01\0\0\x02\x50\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\x01\0\0\0\x03\0\0\0\x20\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\0\0\0\0\xbe\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x09\0\0\0\x02\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\xd8\0\0\0\0\0\0\0\x01\
\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\x18\0\0\0\0\0\0\0\x11\0\0\0\x01\0\0\0\x06\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\xd8\x01\0\0\0\0\0\0\x70\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x2b\0\0\0\x01\0\0\0\x03\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\x48\x02\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\x33\0\0\0\x08\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x4c\x02\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\x38\0\0\0\x01\0\0\0\x02\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x4c\x02\0\0\0\
\0\0\0\x14\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x92\
\0\0\0\x09\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x60\x02\0\0\0\0\0\0\x30\0\0\0\
\0\0\0\0\x02\0\0\0\x03\0\0\0\x08\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\xb0\0\0\0\x01\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x90\x02\0\0\0\0\0\0\xb2\x02\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xb5\0\0\0\x01\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\x48\x05\0\0\0\0\0\0\x80\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";

	return 0;
err:
	bpf_object__destroy_skeleton(s);
	return -1;
}

#endif /* __TRACE_PRINTK_SKEL_H__ */
